package org.puremvc.as3.core.model
{
   import org.puremvc.as3.interfaces.IModel;
   import org.puremvc.as3.interfaces.IProxy;
   
   public class Model implements IModel
   {
      
      protected static var instance:IModel;
       
      
      protected const SINGLETON_MSG:String = "Model Singleton already constructed!";
      
      protected var proxyMap:Array;
      
      public function Model()
      {
         super();
         if(instance != null)
         {
            throw Error(SINGLETON_MSG);
         }
         instance = this;
         proxyMap = new Array();
         initializeModel();
      }
      
      public static function getInstance() : IModel
      {
         if(instance == null)
         {
            instance = new Model();
         }
         return instance;
      }
      
      protected function initializeModel() : void
      {
      }
      
      public function removeProxy(proxyName:String) : IProxy
      {
         var proxy:IProxy = proxyMap[proxyName] as IProxy;
         proxyMap[proxyName] = null;
         return proxy;
      }
      
      public function hasProxy(proxyName:String) : Boolean
      {
         return proxyMap[proxyName] != null;
      }
      
      public function retrieveProxy(proxyName:String) : IProxy
      {
         return proxyMap[proxyName];
      }
      
      public function registerProxy(proxy:IProxy) : void
      {
         proxyMap[proxy.getProxyName()] = proxy;
      }
   }
}
